#########################################################################
#                                                                       #
# An investor wants to put together a  portfolio consisting of a        #
# maximum of 5 stocks. What is the best combination of stocks to get    #
# the optimum return with a given variance (risk) ?                     #
#                                                                       #
#########################################################################

set STOCKS;

##############
# Parameters #
##############

param RETURN {STOCKS};            # Expected return of each stock 
param VARIANCE {STOCKS,STOCKS};   # Variances and covariances of the stocks
param RISK;                       # The percentage risk the investor accepts

#############
# Variables #
#############

var PORTFOLIO_PART {STOCKS} >=0;  # The percentages of the portfolio

#########
# Model #
#########

maximize PORTFOLIO_RETURN:
   sum {i in STOCKS} PORTFOLIO_PART[i]*RETURN[i];
subject to
   Complete_Portfolio:
      sum {i in STOCKS} PORTFOLIO_PART[i] = 1; 
    The_Variance:   
      sum {i in STOCKS} PORTFOLIO_PART[i]*sum {j in STOCKS} PORTFOLIO_PART[j] 
           * VARIANCE[i,j] <= RISK;

