##########################################################################
#                                                                        #
# A company wants to advertise its product through different media.      #
# A limited budget is available. How should the company advertise to     #
# maximize audience?                                                     #
#                                                                        #
##########################################################################

set MEDIA;

##############
# Parameters #
##############

param AUDIENCE {MEDIA};                         # Audience per ad
param COST {MEDIA};                             # Cost per ad
param MANPOWER {MEDIA};                         # Manpower required per ad
param BUDGET;                                   # Available budget
param MANPOWER_AVAILABLE;                       # Number of people available

#############
# Variables #
#############

var INVESTMENT {MEDIA} >=0;                     # Investments

#########
# Model #
#########

maximize TOTAL_AUDIENCE:
   sum {i in MEDIA} INVESTMENT[i]/COST[i]*AUDIENCE[i];
subject to
   Budget:
    sum {i in MEDIA} INVESTMENT[i] <= BUDGET;
   Manpower:
    sum {i in MEDIA} INVESTMENT[i]/COST[i]*MANPOWER[i] <= MANPOWER_AVAILABLE;

