##########################################################################
#                                                                        #
# Maximize the preference of the employees' schedules while maintaining  #
# a schedule that minimizes payroll costs.                               #
#                                                                        #
##########################################################################

set EMPLOYEES;
set SCHEDULES;

##############
# Parameters #
##############

param PREFERENCE {EMPLOYEES,SCHEDULES};     # Preference of employees
param DEMAND {SCHEDULES};                   # Demand per schedule

#############
# Variables #
#############

var DECISIONS {EMPLOYEES,SCHEDULES} binary;  # Assignments

#########
# Model #
#########

maximize TOTAL_PREFERENCE:
  sum {i in EMPLOYEES,j in SCHEDULES} PREFERENCE[i,j]*DECISIONS[i,j];
subject to 
   Demand {j in SCHEDULES}:
      sum {i in EMPLOYEES} DECISIONS[i,j] = DEMAND[j];
   One_schedule_per_employee {i in EMPLOYEES}:
      sum {j in SCHEDULES} DECISIONS[i,j] = 1;

